"""
 SimpleGtkbuilderApp.py
 Module that provides a helper for gtkbuilder, based on SimpleGladeApp
"""

import gtk


class SimpleGtkbuilderApp(object):

    def __init__(self, path):
        self.builder = gtk.Builder()
        self.builder.add_from_file(path)
        self.builder.connect_signals(self)
        for o in self.builder.get_objects():
            if o.get_name():
                setattr(self, o.get_name(), o)

    def run(self):
        """
        Starts the main loop of processing events checking for Control-C.

        The default implementation checks wheter a Control-C is pressed,
        then calls on_keyboard_interrupt().

        Use this method for starting programs.
        """
        try:
            gtk.main()
        except KeyboardInterrupt:
            self.on_keyboard_interrupt()

    def on_keyboard_interrupt(self):
        """
        This method is called by the default implementation of run()
        after a program is finished by pressing Control-C.
        """
        pass

